unit uMain;

interface

uses
   SysUtils, Windows, Classes, Controls, Menus, ComCtrls, StdCtrls, ExtCtrls, Forms,
   Dialogs, SynEdit, Grids, TypInfo, ValEdit, Mask, XPMan, Buttons, CheckLst, OleCtnrs,
   MPlayer, SynHighlighterGeneral;

type

   TWinControls=class of TWinControl;
   TComponents=class of TComponent;

   function SetPropVal(o:pointer; pname,pval:pchar):boolean;stdcall;
   function GetPropVal(o:pointer; pname:pchar;var pval:pchar):boolean;stdcall;

   function Create(var obj:pointer;classname,text:pchar;x:integer=0;y:integer=0;cx:integer=0;cy:integer=0):hwnd;stdcall;
   procedure Destroy(o:pointer);stdcall;

   function Add(par,itm:pointer):integer;stdcall;
   function GetPropertyList(o:pointer;kind:integer=0;filter:pchar=nil):pchar;stdcall;

var
   instances:TList;

implementation

function GetPropertyList(o:pointer;kind:integer=0;filter:pchar=nil):pchar;
var
  Count, Loop: Integer;
  List: PPropList;
  Pif:PPropInfo;
  Strings,lFilter:TStrings;
begin
  result:=nil;
  if o=nil then exit;
  Strings:=TStringList.Create;
  lfilter:=TStringList.Create;
  lfilter.Text:=strpas(filter);

  if kind=0 then
     Count := GetPropList(TObject(o).ClassInfo, tkAny, nil)
  else if kind=1 then
     Count := GetPropList(TObject(o).ClassInfo, tkProperties, nil)
  else if kind=2 then
     Count := GetPropList(TObject(o).ClassInfo, tkMethods, nil)
  else
     Count := GetPropList(TObject(o).ClassInfo, tkAny, nil);

  GetMem(List, Count * SizeOf(PPropInfo));

  try
    if kind=0 then
       GetPropList(TObject(o).ClassInfo, tkAny, List)
    else if kind=1 then
       GetPropList(TObject(o).ClassInfo, tkProperties, List)
    else if kind=2 then
       GetPropList(TObject(o).ClassInfo, tkMethods, List);

    Strings.BeginUpdate;
    for Loop := 0 to Pred(Count) do begin
        //strings.Add(List^[Loop]^.Name);
        if lfilter.IndexOf(List^[Loop]^.Name)=-1 then begin
           pif:=GetPropInfo(TObject(o),List^[Loop]^.Name);
           if pif<>nil then strings.Add(List^[Loop]^.Name);
        end;
    end;
    Strings.EndUpdate;
    result:=pchar(strings.Text);
  finally
    FreeMem(List, Count * SizeOf(PPropInfo))
  end;
  Strings.free;
  lfilter.Free
end;

function Add(par,itm:pointer):integer;
begin
   result:=0;
   if (par<>nil)and(itm<>nil) then
      if TObject(par).InheritsFrom(TMenuItem) then begin
         TMenuItem(par).Add(TMenuItem(itm));
         result:=TMenuItem(itm).Command
      end else if TObject(par).InheritsFrom(TMainMenu) then begin
         TMainMenu(par).Items.Add(TMenuItem(itm)) ;
         result:=TMenuItem(itm).Command
      end else if TObject(par).InheritsFrom(TPopupMenu) then begin
         TPopupMenu(par).Items.Add(TMenuItem(itm));
         result:=TMenuItem(itm).Command
      end else if TObject(par).InheritsFrom(TStrings) then begin
         TStrings(par).Add(strpas(itm))
      end
end;

function SetPropVal(o:pointer; pname,pval:pchar):boolean;
var
  pif:PPropInfo;
  M:TMethod;
  C:TComponent;
begin
    if instances.IndexOf(o)=-1 then begin
       messagedlg('The object is non local thread.',mtinformation,[mbok],0);
       result:=false;
       exit
    end;
    pif:=GetPropInfo(TObject(o),strpas(pname));
    if pif<>nil then begin
       try
          case pif^.PropType^.Kind of
          tkMethod:begin
            copymemory(@M,pointer(pval),sizeof(M));
            SetMethodProp(TObject(o),strpas(pname),m); 
            result:=true;
            end;
          tkClass:begin
            C:=TComponent(pointer(pval));
            SetObjectProp(TObject(o),strpas(pname),C);
            result:=true;
            end;
          else begin
            SetPropValue(TObject(o),strpas(pname),strpas(pval));
            result:=true;
            end
          end
       except
          result:=false
       end;
    end else result:=false
end;

function GetPropVal(o:pointer; pname:pchar;var pval:pchar):boolean;
var
  pif:PPropInfo;
  s:string;
  M:TMethod;
  obj:TObject;
begin
    if instances.IndexOf(o)=-1 then begin
       messagedlg('The object is non local thread.',mtinformation,[mbok],0);
       result:=false;
       exit
    end;
    pif:=GetPropInfo(TObject(o),strpas(pname));
    if pif<>nil then begin
       try
          case pif^.PropType^.Kind of
          tkMethod:begin
            M:=GetMethodProp(TObject(o),strpas(pname));
            copymemory(pval,@M,sizeof(M));
            result:=true;
            end;
          tkClass:begin
            obj:=GetObjectProp(TObject(o),strpas(pname));
            copymemory(pval,@obj,sizeof(obj));
            result:=true;
            end;
          else begin
            s:=GetPropValue(TObject(o),strpas(pname));
            copymemory(pval,pchar(s),length(s));   
            result:=true;
            end
          end
       except
          result:=false
       end;
    end else result:=false
end;

function Create(var obj:pointer;classname,text:pchar;x:integer=0;y:integer=0;cx:integer=0;cy:integer=0):hwnd;
var
   cls:TClass;
   o:TObject;
   Addr:integer;
begin
   result:=0 ;
   cls:=GetClass(strpas(classname));
   if cls<>nil then begin
      if cls.InheritsFrom(TWincontrol) then begin
         o:=TWincontrols(cls).Create(nil);
         with TWinControl(o) do begin
              if iswindow(integer(obj)) then
                 ParentWindow:=integer(obj)
              else
                 Parent:=TWinControl(obj);
              if x>-1 then Left:=x;
              if y>-1 then Top:=y;
              if cx>-1 then Width:=cx;
              if cy>-1 then Height:=cy;
              if GetPropInfo(o,'caption')<>nil then
                 SetPropValue(o,'caption',strpas(text));
              if GetPropInfo(o,'text')<>nil then
                 SetPropValue(o,'text',strpas(text));
              if GetPropInfo(o,'lines')<>nil then begin
                 addr:=GetPropValue(o,'lines');
                 TStrings(addr).text:=strpas(text);
              end;   
              if GetPropInfo(o,'parentbackground')<>nil then
                 SetPropValue(o,'parentbackground',false);
              if GetPropInfo(o,'parentcolor')<>nil then
                 SetPropValue(o,'parentcolor',false);

              result:=handle;
         end ;
         if instances.IndexOf(o)=-1 then
            instances.Add(o) ;
         obj:=o;
      end else begin
         o:=TComponents(cls).Create(nil);
         if not isWindow(integer(obj)) then begin
            if TComponent(o).InheritsFrom(TMainMenu) then
               TForm(obj).Menu:=TMainMenu(o);
            if TComponent(o).InheritsFrom(TMenuItem) then
               if TMenu(obj).InheritsFrom(TMainMenu) then
                  TMainMenu(obj).Items.Add(TMenuItem(o))
               else if TMenu(obj).InheritsFrom(TPopupMenu) then
                  TPopupMenu(obj).Items.Add(TMenuItem(o))
               else if TMenu(obj).InheritsFrom(TMenuItem) then
                  TMenuItem(obj).Add(TMenuItem(o))   ;
         end ;
         if GetPropInfo(o,'caption')<>nil then
                 SetPropValue(o,'caption',strpas(text));
         if TComponent(o).InheritsFrom(TMenuItem) then
            result:=TMenuItem(o).Command
         else if TComponent(o).InheritsFrom(TStrings) then
            result:=TStrings(o).Count
         else
            result:=0;
         if instances.IndexOf(o)=-1 then
            instances.Add(o) ;
         obj:=o;
      end
   end else begin
      if comparetext('tstringlist',lowercase(strpas(classname)))=0 then begin
         o:=TStringList.Create;
         TStringList(o).Text:=strpas(text);
         if instances.IndexOf(o)=-1 then
            instances.Add(o) ;
         obj:=o;
         result:=TStringList(o).Count
      end;
   end
end;

procedure Destroy(o:pointer);
var
   i:integer;
begin
    i:=instances.IndexOf(o);
    if i>-1 then begin
       TObject(o).Free;
       instances.Delete(i);
    end
end;

procedure DisposeAll;
var
  i:integer;
begin
   for i:=instances.Count-1 downto 0 do
       TObject(instances[i]).Free
end;


initialization
    instances:=TList.Create;
    RegisterClasses([TStaticText,TButton,TBitBtn,TCheckBox,TRadioButton,TEdit,TComboBox,
                     TListBox,TScrollBar,TGroupBox,
                     TToolBar,TStatusBar,TTabControl,TPageControl,TRichEdit,TTrackBar,TUpDown,
                     TProgressBar,TAnimate,THotKey,TDateTimePicker,TMonthCalendar,
                     TTreeView,TListView,TCoolBar,TPageScroller,TComboBoxEx,TXPManifest,
                     TMaskEdit,TStringGrid,TDrawGrid,TShape,TBevel,TScrollBox,TCheckListBox,
                     TValueListEditor,TLabeledEdit,TColorBox,TPaintBox,TMediaPlayer,TOleContainer,
                     TMainMenu,TMenuItem,TPopupMenu,TImageList,TTimer,TForm,TSynEdit,TSynGeneralSyn]);
finalization
    DisposeAll;
    instances.Free;
    UnRegisterClasses([TStaticText,TButton,TBitBtn,TCheckBox,TRadioButton,TEdit,TComboBox,
                     TListBox,TScrollBar,TGroupBox,
                     TToolBar,TStatusBar,TTabControl,TPageControl,TRichEdit,TTrackBar,TUpDown,
                     TProgressBar,TAnimate,THotKey,TDateTimePicker,TMonthCalendar,
                     TTreeView,TListView,TCoolBar,TPageScroller,TComboBoxEx,TXPManifest,
                     TMaskEdit,TStringGrid,TDrawGrid,TShape,TBevel,TScrollBox,TCheckListBox,
                     TValueListEditor,TLabeledEdit,TColorBox,TPaintBox,TMediaPlayer,TOleContainer,
                     TMainMenu,TMenuItem,TPopupMenu,TImageList,TTimer,TForm,TSynEdit,TSynGeneralSyn]);
end.
