/'
   This is GUI standards unit in FreeBasic
   is suitable for windows operating system,
   but can be easely translated for Linux systems
   copyright (c)2021 vasile eodor nastasa
   http://www.rqwork.ro
   http://www.rqwork.de
   nastasa.eodor@gmail.com
   this version is number 11, is a stable release(GUI_V11)
'/

#include once "sysutils.bas"

#ifndef cm_command
   #define cm_command wm_app+100
#endif

enum QAlignment
     taLeft,taCenter,taRight
end enum
type QStatic extends QFrame
     protected:
     as QAlignment falignment
     declare virtual sub Dispatch(byref as QMessage)
     declare virtual sub Handler(byref as QMessage)
     declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
     public:
     declare property Alignment as integer
     declare property Alignment (as integer)
     declare property onClick as QEvent
     declare property onClick (as QEvent)
     declare virtual sub Update
     declare static function Register(v as string="QStatic") as integer
     declare operator cast as any ptr
     declare operator cast as string
     declare constructor
     declare destructor
     AllocateRTTI
end type

type QLabel as QStatic

#include once "graphic.bas"

/'QImage'/
type QImage extends QStatic
    protected:
    as ppicture fpicture
    as boolean fcenter
    declare virtual sub Dispatch(byref as QMessage)
    declare static sub PictureChange(as QObject)
    declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
    public:
    declare static function Register(v as string="QImage") as integer
    declare property onClick as QEvent
    declare property onClick (as QEvent)
    declare property Center as integer
    declare property Center (as integer)
    declare property Picture as  QPicture
    declare property Picture (as  QPicture)
    declare virtual operator cast as any ptr
    declare constructor
    declare destructor
    AllocateRTTI
end type

type PButton as QButton ptr
type QButton extends QFrame
     private:
     as QEvent DoClick
     protected:
     declare virtual sub Dispatch(byref as QMessage)
     declare virtual sub Handler(byref as QMessage)
     declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
     public:
     declare property onClick as QEvent
     declare property onClick (as QEvent)
     declare static function Register(v as string="QButton") as integer
     declare operator cast as any ptr
     declare operator cast as string
     declare constructor
     declare destructor
     AllocateRTTI
end type

type QCheckBox extends QFrame
     protected:
     declare virtual sub Dispatch(byref as QMessage)
     declare virtual sub Handler(byref as QMessage)
     declare virtual sub CreateHandle
     declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
     public:
     declare property onClick as QEvent
     declare property onClick (as QEvent)
     declare static function Register(v as string="QCheckBox") as integer
     declare operator cast as any ptr
     declare operator cast as string
     declare constructor
     declare destructor
     AllocateRTTI
end type

type QRadioButton extends QFrame
     protected:
     declare virtual sub Dispatch(byref as QMessage)
     declare virtual sub Handler(byref as QMessage)
     declare virtual sub CreateHandle
     declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
     public:
     declare property onClick as QEvent
     declare property onClick (as QEvent)
     declare static function Register(v as string="QRadioButton") as integer
     declare operator cast as any ptr
     declare operator cast as string
     declare constructor
     declare destructor
     AllocateRTTI
end type

type QGroupBox extends QFrame
     protected:
     declare virtual sub Dispatch(byref as QMessage)
     declare virtual sub Handler(byref as QMessage)
     declare virtual sub CreateHandle
     declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
     public:
     declare property onClick as QEvent
     declare property onClick (as QEvent)
     declare static function Register(v as string="QGroupBox") as integer
     declare operator cast as any ptr
     declare operator cast as string
     declare constructor
     declare destructor
     AllocateRTTI
end type

type QEdit extends QFrame
     protected:
     declare virtual sub Dispatch(byref as QMessage)
     declare virtual sub Handler(byref as QMessage)
     declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
     public:
     declare property onClick as QEvent
     declare property onClick (as QEvent)
     declare static function Register(v as string="QEdit") as integer
     declare operator cast as any ptr
     declare operator cast as string
     declare constructor
     declare destructor
     AllocateRTTI
end type

type QComboBox extends QFrame
     protected:
     declare virtual sub Dispatch(byref as QMessage)
     declare virtual sub Handler(byref as QMessage)
     declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
     public:
     declare property onClick as QEvent
     declare property onClick (as QEvent)
     declare static function Register(v as string="QComboBox") as integer
     declare operator cast as any ptr
     declare operator cast as string
     declare constructor
     declare destructor
     AllocateRTTI
end type

type QListBox extends QFrame
     protected:
     declare virtual sub Dispatch(byref as QMessage)
     declare virtual sub Handler(byref as QMessage)
     declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
     public:
     declare property onClick as QEvent
     declare property onClick (as QEvent)
     declare static function Register(v as string="QListBox") as integer
     declare operator cast as any ptr
     declare operator cast as string
     declare constructor
     declare destructor
     AllocateRTTI
end type

type QScrollBar extends QFrame
     protected:
     declare virtual sub Dispatch(byref as QMessage)
     declare virtual sub Handler(byref as QMessage)
     declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
     public:
     declare property onClick as QEvent
     declare property onClick (as QEvent)
     declare static function Register(v as string="QScrollBar") as integer
     declare operator cast as any ptr
     declare operator cast as string
     declare constructor
     declare destructor
     AllocateRTTI
end type

#include once "standards.inc"

/'Register to ide'/
namespace Standards
    function RegisterComponents as zstring ptr export
        dim as string s="Standards:QStatic,QImage,QButton,QCheckBox,QRadioButton,QGroupBox,QEdit,QComboBox,QListBox,QScrollBar"+chr(0)
        dim as zstring ptr result=callocate(len(s))
        *result=s
        return result
    end function
end namespace

property QStatic.Alignment as integer
    if fstyle and ss_left=ss_left then
       falignment=taLeft
    elseif fstyle and ss_center=ss_center then
       falignment=taCenter
    elseif fstyle and (ss_center or ss_left)=(ss_center or ss_left)then
       falignment=taRight
    end if
    return falignment
end property

property QStatic.Alignment (v as integer)
    falignment=v
    select case v
    case 0:fstyle or=ss_left
           fstyle and=not (ss_center or ss_right)
    case 1:fstyle or=ss_center
           fstyle and=not (ss_left or ss_right)
    case 2:fstyle or=ss_right
           fstyle and=not (ss_center or ss_left)
    end select
    fstyle=fstyle
    Update
end property

property QStatic.onClick as QEvent
    return Base.onclick
end property

property QStatic.onClick (v as QEvent)
    Base.onclick=v
end property

sub QStatic.Update
    'Base.UpdateControl
end sub

sub QStatic.Handler(byref m as QMessage)
    Base.Handler(m)
end sub

sub QStatic.Dispatch(byref m as QMessage)
    base.Dispatch(m)
end sub

function QStatic.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
     dim as PFrame F=iif(self,self,cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-sizeof(integer))))
     dim as QMessage m=type(dlg,msg,wparam,lparam,0,F)
     if F then
        F->fhandle=dlg
        F->dispatch(m)
        if m.result=0 then F->handler(m)
        return m.result
     else
        F=new QStatic
        F->fhandle=dlg
        F->dispatch(m)
        if m.result=0 then F->handler(m)
        return m.result
     end if
     return m.result
end function

function QStatic.Register(v as string="QStatic") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if getclassinfoex(0,"static",@wcls) then
       wcls.cbwndextra+=sizeof(integer)
       wcls.lpfnwndproc=@qstatic.dlgproc
       wcls.lpszclassname=strptr(v)
       wcls.hinstance=instance
       return RegisterClassEx(@wcls)
    end if
    return 0
end function

operator QStatic.cast as any ptr
    return @this
end operator

operator QStatic.cast as string
    return iif(classname<>"",classname,"QStatic")
end operator

constructor QStatic
    classname="QStatic"
    classAncestor="static"
    fstyle=ws_child or ss_notify or ss_simple
    fwidth=97
    fheight=17
    fcolor=&hffffff
end constructor

destructor QStatic
end destructor

/'QImage'/
property QImage.onClick as QEvent
    return Base.onClick
end property

property QImage.onClick (v as QEvent)
    Base.onClick=v
end property

function QImage.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
     dim as PFrame F=iif(self,self,cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-4)))
     dim as QMessage m=type(dlg,msg,wparam,lparam,0,F)
     if F then
        F->fhandle=dlg
        F->dispatch(m)
        if m.result=0 then F->handler(m)
        return m.result
     else
        F=new QImage
        F->fhandle=dlg
        F->dispatch(m)
        if m.result=0 then F->handler(m)
        return m.result
     end if
     return m.result
end function

function QImage.Register(v as string="QImage") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if getclassinfoex(0,"static",@wcls) then
       wcls.cbwndextra+=sizeof(integer)
       wcls.lpfnwndproc=@qimage.dlgproc
       wcls.lpszclassname=strptr(v)
       wcls.hinstance=instance
       return RegisterClassEx(@wcls)
    end if
    return 0
end function

sub QImage.Dispatch(byref m as QMessage)
    base.Dispatch(m)
    select case m.msg
    case stm_setimage
         fpicture->handle=cast(any ptr,m.lparam)
         select case m.wparam
         case image_bitmap
         case image_cursor
         case image_icon
         case image_enhmetafile
         end select
         m.result=0
    end select
end sub

property QImage.Picture as QPicture
    if fpicture then
       return *fpicture
    else
       return *cast(ppicture,0)
    end if
end property

property QImage.Picture (v as QPicture)
    fpicture=v
end property

property QImage.Center as integer
    fcenter=fstyle and ss_centerimage
    return fcenter
end property

property QImage.Center (v as integer)
    fcenter=v
    if v then
       fstyle or=ss_centerimage
    else
       fstyle and=not ss_centerimage
    end if
    fstyle=fstyle
end property

sub QImage.PictureChange(sender as QObject)
    dim as integer it=image_bitmap
    with *cast(PPicture,@sender)
         dim as string ext=extractfileext(.filename)
         select case lcase(ext)
         case ".bmp": it=image_bitmap
                     cast(PFrame,.interface)->fstyle=cast(PFrame,.interface)->fstyle or ss_bitmap and not (ss_icon  or ss_enhmetafile)
         case ".cur",".ico":it=image_icon
                     cast(PFrame,.interface)->fstyle=cast(PFrame,.interface)->fstyle or ss_icon and not (ss_bitmap or ss_enhmetafile)
         end select
         SendMessage(cast(PFrame,.interface)->Handle,stm_setimage,it,cint(.handle))
    end with
end sub

operator QImage.cast as any ptr
    return @this
end operator

constructor QImage
    classname="QImage"
    classancestor="static"
    fstyle=ss_bitmap or ws_child or ss_notify
    fwidth=105
    fHeight=105
    fpicture=new QPicture
    if fpicture then
       fpicture->interface=@this
       fpicture->onchange=@picturechange
    end if
end constructor

destructor QImage
    if fpicture then delete fpicture
end destructor


/'QButton'/
property QButton.onClick as QEvent
    return Base.onClick
end property

property QButton.onClick (v as QEvent)
    Base.onClick=v   :? base.onclick
    DoClick=v    :? DoClick
end property

sub QButton.Handler(byref m as QMessage)
    Base.Handler(m)
end sub

sub QButton.Dispatch(byref m as QMessage)
    base.Dispatch(m)
    select case m.msg
    case cm_command 
         if hiword(m.wparam)=bn_clicked then 
            if base.onclick then 
               base.onclick(this)
            elseif DoClick then
               DoClick(this)
            end if
         end if         
         m.result=0
    case cm_notify
         if  m.msg=nm_click then if base.onclick then base.onclick(this)
         m.result=0
    end select
end sub

function QButton.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as PFrame F=iif(self,self,cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-4)))
    dim as QMessage m=type(dlg,msg,wparam,lparam,0,F)
    if F then
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    else
       F=new QButton
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    end if
    return m.result
end function

function QButton.Register(v as string="QButton") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if getclassinfoex(0,"button",@wcls) then
       wcls.cbwndextra+=sizeof(integer)
       wcls.lpfnwndproc=@dlgproc
       wcls.lpszclassname=strptr(v)
       wcls.hinstance=instance
       return RegisterClassEx(@wcls)
    end if
    return 0
end function

operator QButton.cast as any ptr
    return @this
end operator

operator QButton.cast as string
    return iif(classname<>"",classname,"QButton")
end operator

constructor QButton
    classname="QButton"
    classAncestor="Button"
    fstyle=ws_child
    fwidth=75
    fheight=35
end constructor

destructor QButton
end destructor


/'QCheckBox'/
property QCheckBox.onClick as QEvent
    return Base.onClick
end property

property QCheckBox.onClick (v as QEvent)
    Base.onClick=v
end property

sub QCheckBox.Handler(byref m as QMessage)
    Base.Handler(m)
end sub

sub QCheckBox.Dispatch(byref m as QMessage)
    base.Dispatch(m)
    select case m.msg
    case cm_command
         if m.wparam=bn_clicked then click
    end select
end sub

sub QCheckBox.CreateHandle
    Base.CreateHandle
end sub

function QCheckBox.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as PFrame F=iif(self,self,cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-4)))
    dim as QMessage m=type(dlg,msg,wparam,lparam,0,F)
    if F then
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    else
       F=new QCheckBox
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    end if
    return m.result
end function

function QCheckBox.Register(v as string="QCheckBox") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if getclassinfoex(0,"button",@wcls) then
       wcls.cbwndextra+=sizeof(integer)
       wcls.lpfnwndproc=@dlgproc
       wcls.lpszclassname=strptr(v)
       wcls.hinstance=instance
       return RegisterClassEx(@wcls)
    end if
    return 0
end function

operator QCheckBox.cast as any ptr
    return @this
end operator

operator QCheckBox.cast as string
    return iif(classname<>"",classname,"QCheckBox")
end operator

constructor QCheckBox
    classname="QCheckBox"
    classAncestor="Button"
    fstyle=ws_child or bs_autocheckbox
    fwidth=75
    fheight=35
end constructor

destructor QCheckBox
end destructor

/'QRadioButton'/
property QRadioButton.onClick as QEvent
    return Base.onClick
end property

property QRadioButton.onClick (v as QEvent)
    Base.onClick=v
end property

sub QRadioButton.Handler(byref m as QMessage)
    Base.Handler(m)
end sub

sub QRadioButton.Dispatch(byref m as QMessage)
    base.Dispatch(m)
    select case m.msg
    case cm_command
         'if m.wparam=bn_clicked then click
    end select
end sub

sub QRadioButton.CreateHandle
    Style=ws_child or bs_autoradiobutton
    Base.CreateHandle
end sub

function QRadioButton.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as PFrame F=iif(self,self,cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-4)))
    dim as QMessage m=type(dlg,msg,wparam,lparam,0,F)
    if F then
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    else
       F=new QRadioButton
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    end if
    return m.result
end function

function QRadioButton.Register(v as string="QRadioButton") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if getclassinfoex(0,"button",@wcls) then
       wcls.cbwndextra+=sizeof(integer)
       wcls.lpfnwndproc=@dlgproc
       wcls.lpszclassname=strptr(v)
       wcls.hinstance=instance
       return RegisterClassEx(@wcls)
    end if
    return 0
end function

operator QRadioButton.cast as any ptr
    return @this
end operator

operator QRadioButton.cast as string
    return iif(classname<>"",classname,"QRadioButton")
end operator

constructor QRadioButton
    classname="QRadioButton"
    classAncestor="Button"
    fstyle=ws_child or bs_autoradiobutton
    fwidth=75
    fheight=35
end constructor

destructor QRadioButton
end destructor


/'QGroupBox'/
property QGroupBox.onClick as QEvent
    return Base.onClick
end property

property QGroupBox.onClick (v as QEvent)
    Base.onClick=v
end property

sub QGroupBox.Handler(byref m as QMessage)
    Base.Handler(m)
end sub

sub QGroupBox.Dispatch(byref m as QMessage)
    base.Dispatch(m)
    select case m.msg
    case cm_command
         'if m.wparam=bn_clicked then click
    end select
end sub

sub QGroupBox.CreateHandle
    Style=ws_child or bs_groupbox
    Base.CreateHandle
end sub

function QGroupBox.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as PFrame F=iif(self,self,cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-4)))
    dim as QMessage m=type(dlg,msg,wparam,lparam,0,F)
    if F then
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    else
       F=new QGroupBox
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    end if
    return m.result
end function

function QGroupBox.Register(v as string="QGroupBox") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if getclassinfoex(0,"button",@wcls) then
       wcls.cbwndextra+=sizeof(integer)
       wcls.lpfnwndproc=@dlgproc
       wcls.lpszclassname=strptr(v)
       wcls.hinstance=instance
       return RegisterClassEx(@wcls)
    end if
    return 0
end function

operator QGroupBox.cast as any ptr
    return @this
end operator

operator QGroupBox.cast as string
    return iif(classname<>"",classname,"QGroupBox")
end operator

constructor QGroupBox
    classname="QGroupBox"
    classAncestor="Button"
    fstyle=ws_child or bs_groupbox
    fwidth=75
    fheight=35
end constructor

destructor QGroupBox
end destructor

/'QEdit'/
property QEdit.onClick as QEvent
    return Base.onClick
end property

property QEdit.onClick (v as QEvent)
    Base.onClick=v
end property

sub QEdit.Handler(byref m as QMessage)
    Base.Handler(m)
end sub

sub QEdit.Dispatch(byref m as QMessage)
    base.Dispatch(m)
end sub

function QEdit.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as PFrame F=iif(self,self,cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-4)))
    dim as QMessage m=type(dlg,msg,wparam,lparam,0,F)
    if F then
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    else
       F=new QEdit
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    end if
    return m.result
end function

function QEdit.Register(v as string="QEdit") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if getclassinfoex(0,"edit",@wcls) then
       wcls.cbwndextra+=sizeof(integer)
       wcls.lpfnwndproc=@dlgproc
       wcls.lpszclassname=strptr(v)
       wcls.hinstance=instance
       return RegisterClassEx(@wcls)
    end if
    return 0
end function

operator QEdit.cast as any ptr
    return @this
end operator

operator QEdit.cast as string
    return iif(classname<>"",classname,"QEdit")
end operator

constructor QEdit
    classname="QEdit"
    classAncestor="edit"
    fstyle=ws_child
    fwidth=97
    fheight=17
end constructor

destructor QEdit
end destructor

/'QComboBox'/
property QComboBox.onClick as QEvent
    return Base.onClick
end property

property QComboBox.onClick (v as QEvent)
    Base.onClick=v
end property

sub QComboBox.Handler(byref m as QMessage)
    Base.Handler(m)
end sub

sub QComboBox.Dispatch(byref m as QMessage)
    base.Dispatch(m)
end sub

function QComboBox.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as PFrame F=iif(self,self,cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-4)))
    dim as QMessage m=type(dlg,msg,wparam,lparam,0,F)
    if F then
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    else
       F=new QComboBox
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    end if
    return m.result
end function

function QComboBox.Register(v as string="QComboBox") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if getclassinfoex(0,"combobox",@wcls) then
       wcls.cbwndextra+=sizeof(integer)
       wcls.lpfnwndproc=@dlgproc
       wcls.lpszclassname=strptr(v)
       wcls.hinstance=instance
       return RegisterClassEx(@wcls)
    end if
    return 0
end function

operator QComboBox.cast as any ptr
    return @this
end operator

operator QComboBox.cast as string
    return iif(classname<>"",classname,"QComboBox")
end operator

constructor QComboBox
    classname="QComboBox"
    classAncestor="combobox"
    fstyle=ws_child
    fwidth=121
    fheight=21
end constructor

destructor QComboBox
end destructor

/'QListBox'/
property QListBox.onClick as QEvent
    return Base.onClick
end property

property QListBox.onClick (v as QEvent)
    Base.onClick=v
end property

sub QListBox.Handler(byref m as QMessage)
    Base.Handler(m)
end sub

sub QListBox.Dispatch(byref m as QMessage)
    base.Dispatch(m)
end sub

function QListBox.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as PFrame F=iif(self,self,cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-4)))
    dim as QMessage m=type(dlg,msg,wparam,lparam,0,F)
    if F then
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    else
       F=new QListBox
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    end if
    return m.result
end function

function QListBox.Register(v as string="QListBox") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if getclassinfoex(0,"listbox",@wcls) then
       wcls.cbwndextra+=sizeof(integer)
       wcls.lpfnwndproc=@dlgproc
       wcls.lpszclassname=strptr(v)
       wcls.hinstance=instance
       return RegisterClassEx(@wcls)
    end if
    return 0
end function

operator QListBox.cast as any ptr
    return @this
end operator

operator QListBox.cast as string
    return iif(classname<>"",classname,"QListBox")
end operator

constructor QListBox
    classname="QListBox"
    classAncestor="listbox"
    fstyle=ws_child
    fwidth=121
    fheight=121
end constructor

destructor QListBox
end destructor

/'QScrollBar'/
property QScrollBar.onClick as QEvent
    return Base.onClick
end property

property QScrollBar.onClick (v as QEvent)
    Base.onClick=v
end property

sub QScrollBar.Handler(byref m as QMessage)
    Base.Handler(m)
end sub

sub QScrollBar.Dispatch(byref m as QMessage)
    base.Dispatch(m)
end sub

function QScrollBar.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as PFrame F=iif(self,self,cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-4)))
    dim as QMessage m=type(dlg,msg,wparam,lparam,0,F)
    if F then
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    else
       F=new QScrollBar
       F->fhandle=dlg
       F->dispatch(m)
       if m.result=0 then F->handler(m)
       return m.result
    end if
    return m.result
end function

function QScrollBar.Register(v as string="QScrollBar") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if getclassinfoex(0,"scrollbar",@wcls) then
       wcls.cbwndextra+=sizeof(integer)
       wcls.lpfnwndproc=@dlgproc
       wcls.lpszclassname=strptr(v)
       wcls.hinstance=instance
       return RegisterClassEx(@wcls)
    end if
    return 0
end function

operator QScrollBar.cast as any ptr
    return @this
end operator

operator QScrollBar.cast as string
    return iif(classname<>"",classname,"QScrollBar")
end operator

constructor QScrollBar
    classname="QScrollBar"
    classAncestor="scrollbar"
    fstyle=ws_child
    fwidth=221
    fheight=17
end constructor

destructor QScrollBar
end destructor

sub standards_initialization constructor
     QForm.register
     QStatic.register
     QImage.register
     QButton.register
     QCheckBox.Register
     QRadioButton.Register
     QGroupBox.Register
     QEdit.register
     QComboBox.register
     QListBox.register
     QScrollBar.register
end sub

sub standard_finalization destructor
    unregisterclass("QForm",instance)
    unregisterclass("QStatic",instance)
    unregisterclass("QImage",instance)
    unregisterclass("QButton",instance)
    unregisterclass("QCheckBox",instance)
    unregisterclass("QRadioButton",instance)
    unregisterclass("QGroupBox",instance)
    unregisterclass("QEdit",instance)
    unregisterclass("QComboBox",instance)
    unregisterclass("QListBox",instance)
    unregisterclass("QScrollBar",instance)
end sub
