/'Graphic'/
type PFont as QFont ptr
type QFont extends QObject
    protected:
     as colorref fcolor
     as integer fcharset
     as hwnd finterface
     as hfont fhandle
     as string ffacename
     as integer fsize
     as boolean fbold
     as boolean fitalic
     as boolean funderline
     as boolean fstrikeout
     declare sub CreateHandle
     public:
     declare property Handle as hfont
     declare property Handle (as hfont)
     declare property FaceName as string
     declare property FaceName(as string)
     declare property Color byref as colorref
     declare property Color (byref as colorref)
     declare property CharSet as integer
     declare property CharSet(as integer)
     declare property Size as integer
     declare property Size(as integer)
     declare property Bold as boolean
     declare property Bold(as boolean)
     declare property Italic as boolean
     declare property Italic(as boolean)
     declare property Underline as boolean
     declare property Underline(as boolean)
     declare property Strikeout as boolean
     declare property Strikeout(as boolean)
     declare property Interface as hwnd
     declare property Interface (as hwnd)
     declare operator cast as any ptr
     declare operator cast as hfont
     declare operator cast as string
     declare operator let( as hfont)
     declare operator let( as pfont)
     declare operator let( as string)
     declare sub updateinterface
     declare constructor
     declare destructor
     AllocateRTTI
end type


#include once "font.inc"

sub QFont.CreateHandle
    if fhandle then deleteobject(fhandle)
    dim as hdc dc=GetDC(0)
    fhandle=createfont(-MulDiv(fsize, GetDeviceCaps(DC, LOGPIXELSY), 72),0,0,0,iif(fbold,700,400),fitalic,funderline,fstrikeout,default_charset,out_default_precis,clip_default_precis,default_pitch,0,ffacename)
    releaseDC(0,dc)
end sub

property QFont.Interface as hwnd
    return finterface
end property

property QFont.Interface (v as hwnd)
    finterface=v
    updateinterface
end property

property QFont.Handle as hfont
    return fhandle
end property

property QFont.Handle (v as hfont)
    dim  as logfont lgf
    if v then
       if getobject(v,sizeof(lgf),@lgf) then
          ffacename=lgf.lffacename
          fbold=iif(lgf.lfwidth>400,true,false)
          fitalic=lgf.lfitalic
          funderline=lgf.lfunderline
          fstrikeout=lgf.lfstrikeout
       end if
    end if
    fhandle=v
end property

property QFont.CharSet as integer
    dim as logfont lgf
    if getobject(fhandle,sizeof(lgf),@lgf) then
       dim as hdc dc=getdc(0)
       fcharset=lgf.lfcharset
       releasedc(0,dc)
    end if
    return fcharset
end property

property QFont.CharSet(v as integer)
    fcharset=v
    createhandle
end property

property QFont.Size as integer
    dim as logfont lgf
    if getobject(fhandle,sizeof(lgf),@lgf) then
       dim as hdc dc=getdc(0)
       fsize=-MulDiv(72, lgf.lfheight, GetDeviceCaps(DC, LOGPIXELSY))
       releasedc(0,dc)
    end if /''/
    return fsize
end property

property QFont.Size (v as integer)
    fsize=v
    createhandle
end property

property QFont.FaceName as string
    if fhandle then
       dim as logfont lgf
       if getobject(fhandle,sizeof(lgf),@lgf) then
          ffacename=lgf.lffacename
       end if
    end if
    return ffacename
end property

property QFont.FaceName(v as string)
    ffacename=v
    CreateHandle
    updateinterface
end property

property QFont.Color byref as colorref
    return fcolor
end property

property QFont.Color (byref v as colorref)
    fcolor=v
    CreateHandle
    updateinterface
end property

property QFont.Bold as boolean
    if fhandle then
       dim as logfont lgf
       if getobject(fhandle,sizeof(lgf),@lgf) then
          fbold=lgf.lfweight=700
       end if
    end if
    return fbold
end property

property QFont.Bold(v as boolean)
    fbold=v
    createhandle
    updateinterface
end property

property QFont.Italic as boolean
    if fhandle then
       dim as logfont lgf
       if getobject(fhandle,sizeof(lgf),@lgf) then
          fitalic=lgf.lfitalic
       end if
    end if
    return fitalic
end property

property QFont.Italic(v as boolean)
    fitalic=v
    createhandle
    updateinterface
end property

property QFont.Underline as boolean
    if fhandle then
       dim as logfont lgf
       if getobject(fhandle,sizeof(lgf),@lgf) then
          funderline=lgf.lfunderline
       end if
    end if
    return funderline
end property

property QFont.Underline(v as boolean)
    funderline=v
    createhandle
    updateinterface
end property

property QFont.Strikeout as boolean
    if fhandle then
       dim as logfont lgf
       if getobject(fhandle,sizeof(lgf),@lgf) then
          fstrikeout=lgf.lfstrikeout
       end if
    end if
    return fstrikeout
end property

property QFont.Strikeout(v as boolean)
    fstrikeout=v
    createhandle
    updateinterface
end property

sub QFont.updateinterface
    if iswindow(finterface) then
       sendMessage(interface,wm_setfont,cint(fhandle),true)
    end if
end sub

operator QFont.cast as any ptr
    return @this
end operator

operator QFont.cast as hfont
    return fhandle
end operator

operator QFont.cast as string
    return ffacename
end operator

operator QFont.let(v as hfont)
    dim as logfont lgf
    if getobject(v,sizeof(lgf),@lgf) then
       if fhandle then deleteobject(fhandle)
       fhandle=createfontindirect(@lgf)
       ffacename=lgf.lffacename
       dim as hdc dc=getdc(0)
       fsize=-MulDiv(GetDeviceCaps(DC, LOGPIXELSY), 72, lgf.lfheight)
       releasedc(0,dc)
       updateinterface
    end if
end operator

operator QFont.let(v as pfont)
    dim as logfont lgf
    if getobject(v->fhandle,sizeof(lgf),@lgf) then
       if fhandle then deleteobject(fhandle)
       fhandle=createfontindirect(@lgf)
       ffacename=lgf.lffacename
       dim as hdc dc=getdc(0)
       fsize=-MulDiv(GetDeviceCaps(DC, LOGPIXELSY), 72, lgf.lfheight)
       releasedc(0,dc)
       updateinterface
    end if
end operator

operator QFont.let(v as string)
    ffacename=v
    CreateHandle
    updateinterface
end operator

constructor QFont
    ffacename="Tahoma"
    fsize=8
    createhandle
end constructor

destructor QFont
    if fhandle then deleteobject(fhandle)
end destructor