#include once "windows.bi"
#include once "win/commctrl.bi"

#define instance GetModuleHandle(0)
#define objFromHwnd(dlg) cast(PFrame,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-sizeof(integer)))
#define rtl

#ifndef cm_update
  #define cm_update 10001
#endif
#ifndef cm_command
  #define cm_command 10002
#endif
#ifndef cm_notify
  #define cm_notify 10003
#endif
#ifndef cm_click
  #define cm_click 10004
#endif
#ifndef cm_dblclick
  #define cm_dblclick 10005
#endif
#ifndef cm_ctlcolor
  #define cm_ctlcolor 10006
#endif

type PObject as QObject ptr
type PWinFrame as QWinFrame ptr
type PFrame as QFrame ptr
type PForm as QForm ptr
type PApplication as QApplication ptr

common shared as pframe self

type QMessage
    as hwnd dlg
    as uint msg
    as wparam wparam
    as lparam lparam
    as lresult result
    as PObject sender
end type

#ifdef rtl
  enum QELTypeKind
      tkUnknown,tkByte,tkShort,tkInteger,tkLong,tkSingle,tkDouble,tkZString,tkString,tkAny,tkBool,tkSet,tkEnum,tkType,tkMethod
  end enum

  type PELPropInfo as QELPropInfo ptr
  type QELPropInfo field=8
      as QELTypeKind typekind
      as zstring ptr typename,name,value,editor
  end type
  
  common shared as PELPropInfo PropInfo

  type QPersistent extends Object
      declare abstract function GetPropList as zstring ptr
      declare abstract function GetPropInfo(n as string) as PELPropInfo
      declare abstract function GetPropValue(n as string) as zstring ptr
      declare abstract function SetPropValue(n as string,v as zstring ptr) as boolean
      declare abstract function InheritsFrom(n as string) as boolean
      declare abstract function MethodExists(m as string) as any ptr
  end type

  #macro RTTI
      declare virtual function GetPropList as zstring ptr
      declare virtual function GetPropInfo(n as string) as PELPropInfo
      declare virtual function GetPropValue(n as string) as zstring ptr
      declare virtual function SetPropValue(n as string,v as zstring ptr) as boolean
      declare virtual function InheritsFrom(n as string) as boolean
      declare virtual function MethodExists(m as string) as any ptr
  #endmacro


  function strToEvKind(n as string) as string
     select case lcase(n)
     case "onclick","ondblclick","oncreate","ondestroy","onpaint"
           return "QEvent"
     case "ondata"
           return "QDataEvent"
     case "oncommand"
           return "QCommandEvent"
     case "onmenu","onaccel"
           return "QMenuEvent"
     case "onmousedown","onmouseup"
           return "QMouseEvent"
     case "onmousemove"
          return "QMouseMoveEvent"
     case "onkeydown","onkeyup"
          return "QKeyEvent"
     case "onkeypress"
          return "QCharEvent"
     case "onmousewheel"
          return "QMouseWheelEvent"
     end select
  end function
#endif

#macro AllocateRTTI
#ifdef rtl
     RTTI
#endif
#endmacro

#ifdef rtl
type QObject extends QPersistent
#else
type QObject extends Object
#endif
    as integer Tag
    as string name,classname,classancestor
    declare operator cast as object
    declare operator cast as string
    AllocateRTTI
end type

type QEvent as sub(byref as QObject)
type QCloseEvent as sub(byref as QObject,byref as integer=1)
type QCommandEvent as sub(byref as QObject,as integer,as integer,as hwnd)
type QMenuEvent as sub(byref as QObject,as integer)
type QMouseEvent as sub(byref as QObject,as integer,as integer,as integer,as integer)
type QMouseMoveEvent as sub(byref as QObject,as integer,as integer,as integer)
type QKeyEvent as sub(byref as QObject,as integer,as integer)
type QCharEvent as sub(byref as QObject,as byte)
type QMouseWheelEvent as sub(byref as QObject,as integer,as integer,as integer,as integer)
type QDataEvent as sub(byref as QObject,as hwnd,as copydatastruct ptr)

enum QControlAlign
    alNone,alLeft,alRight,alTop,alBottom,alClient
end enum

enum QWindowState
    wsNormal,wsHide,wsMinimized,wsMaximized,wsRestored
end enum

enum QControlStyle
    csDefault,csTransparent,csAcceptChild
end enum

enum QControlState
    csNormal,csStayOnTop,csCanCopy
end enum

#include once "classes.bas"
#include once "font.bas"
#include once "graphic.bas"
#include once "menus.bas"

type QWinFrame extends QObject
    protected:
    as QControlAlign falign
    as hwnd fhandle, fparentwnd
    as pframe fparent, fmdi, factive
    as colorref fcolor
    as pFont ffont
    as pCursor fcursor
    as pBrush fbrush
    as pIcon ficon
    as integer fexstyle,fstyle,fid,fleft,ftop,fwidth,fheight,fclientwidth,fclientheight,foldz,fcontrolstyle,fcontrolstate, fmodalresult
    as string ftext,fhint
    as rect fclientrect,fwindowrect
    as boolean fenabled,fvisible,fshowhint,fclipped,ftabstop,fgrouped
    as QEvent fonpaint,foncreate
    declare abstract sub Dispatch(byref as QMessage)
    declare abstract sub Handler(byref as QMessage)
    declare abstract sub CreateHandle
    declare abstract sub Refresh
    AllocateRTTI
end type

type QFrame extends QWinFrame
     protected:
     as integer fcontrolcount
     as pframe ptr fcontrols
     as ppopupmenu fpopupmenu
     declare virtual sub Dispatch(byref as QMessage)
     declare virtual sub Handler(byref as QMessage)
     declare virtual sub CreateHandle
     declare sub Add(as pframe)
     declare sub Remove(as pframe)
     declare sub RequestAlign
     public:
     declare virtual sub Refresh
     declare function IndexOf(as pframe) as integer
     declare function Perform(as uint,as wparam,as lparam) as lresult
     declare sub SetBounds overload(as integer,as integer,as integer,as integer)
     declare sub SetBounds overload(as rect)
     declare sub AdjustClient overload(as rect)
     declare sub AdjustClient overload(as integer,as integer,as integer,as integer)
     declare sub Click
     declare sub DblClick
     declare sub FreeHandle
     declare sub SetFocus
     declare sub KillFocus
     declare sub BringToFront
     declare sub SendToBack
     declare sub Repaint
     declare sub Invalidate
     'declare sub Refresh
     declare sub Recreate
     declare virtual sub Update
     declare virtual sub UpdateControl
     declare sub ScreenToClient(as point)
     declare sub ClientToScreen(as point)
     declare property Font as QFont
     declare property Font(as QFont)
     declare property Color as integer
     declare property Color (as integer)
     declare property id as integer
     declare property id(as integer)
     declare property ControlStyle as integer
     declare property ControlStyle(as integer)
     declare property ControlState as integer
     declare property ControlState(as integer)
     declare property ShowHint as boolean
     declare property ShowHint (as boolean)
     declare property Cursor as integer
     declare property Cursor(as integer)
     declare property Hint as string
     declare property Hint (as string)
     declare property Clipped as boolean
     declare property Clipped (as boolean)
     declare property Grouped as boolean
     declare property Grouped (as boolean)
     declare property TabStop as boolean
     declare property TabStop (as boolean)
     declare property onPaint as QEvent
     declare property onPaint (as QEvent)
     declare property Handle as hwnd
     declare property Handle (as hwnd)
     declare property Parent as pframe
     declare property Parent (as pframe)
     declare property ParentWnd as hwnd
     declare property ParentWnd (as hwnd)
     declare property Style as integer
     declare property Style (as integer)
     declare property ExStyle as integer
     declare property ExStyle (as integer)
     declare property Align as integer
     declare property Align (as integer)
     declare property Left as integer
     declare property Left (as integer)
     declare property Top as integer
     declare property Top (as integer)
     declare property Width as integer
     declare property Width (as integer)
     declare property Height as integer
     declare property Height (as integer)
     declare property ClientWidth as integer
     declare property ClientWidth( as integer)
     declare property ClientHeight as integer
     declare property ClientHeight( as integer)
     declare property ClientRect as rect
     declare property ClientRect( as rect)
     declare property WindowRect as rect
     declare property WindowRect( as rect)
     declare property Enabled as boolean
     declare property Enabled (as boolean)
     declare property Visible as boolean
     declare property Visible (as boolean)
     declare property Text as string
     declare property Text (as string)
     declare property ControlCount as integer
     declare property Control(as integer) as PFrame
     declare operator cast as pobject
     declare operator cast as string
     declare constructor
     declare destructor
     as QEvent onInitDialog,onClick,onDblClick,onCreate,onDestroy
     as QDataEvent onData
     as QCommandEvent onCommand
     as QMenuEvent onMenu,onAccel
     as QMouseEvent onMouseDown,onMouseUp
     as QMouseMoveEvent onMouseMove
     as QKeyEvent onKeyDown,onKeyUp
     as QCharEvent onKeyPress
     as QMouseWheelEvent onMouseWheel
     AllocateRTTI
end type

type PGeneric as QGeneric ptr
type QGeneric extends QFrame
    protected:
    as pframe fparent
    as string fhost
    declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
    public:
    declare static function Register as integer
    declare property Host as string
    declare property Host (as string)
    declare property Parent as pframe
    declare property Parent (as pframe)
    declare operator cast as pframe
    declare constructor
    declare destructor
    AllocateRTTI
end type

enum QBorderIcons
    biNone,biMaximixe,biMinimize
end enum

enum QFormStyle
    fsNormal,fsMDIClient,fsMDIChild,fsStayOnTop
end enum

enum QFormBorder
     bsNone,bsSingle,bsSizeable,bsSizeTool,bsToolWindow
end enum

type QForm extends QFrame
      protected:
      as QWindowState fwindowstate
      as PMainMenu fmainmenu
      as QBorderIcons fbordericons
      as QFormStyle fformstyle
      as QFormBorder fformborder
      as boolean fismodal
      declare static function DlgProc(as hwnd,as uint,as wparam,as lparam) as lresult
      declare virtual sub Dispatch(byref as QMessage)
      declare virtual sub Handler(byref as QMessage)
      public:
      declare property Icon byref as QICon
      declare property Icon (byref as QICon)
      declare property WindowState as integer
      declare property WindowState (as integer)
      declare property BorderIcons as integer
      declare property BorderIcons (as integer)
      declare property FormStyle as integer
      declare property FormStyle (as integer)
      declare property FormBorder as integer
      declare property FormBorder (as integer)
      declare property MainMenu byref as QMainMenu
      declare property MainMenu (byref as QMainMenu)
      declare property PopupMenu byref as QPopupMenu
      declare property PopupMenu (byref as QPopupMenu)
      declare function ShowModal as integer
      declare sub Close
      declare static function Register(as string="QForm") as integer
      declare operator cast as pframe
      declare operator cast as string
      declare constructor
      declare destructor
      onCreate as QEvent
      onShow as QEvent
      onClose as QCloseEvent
      AllocateRTTI
end type

type QApplication extends QForm
      protected:
      as boolean fterminated
      as QList fWindows
      declare sub UpdateWindowsList
      declare static function EnumWindowsProc(dlg as hwnd,as lparam) as boolean
      public:
      declare property WinList byref as QList
      declare property WindowCount as integer
      declare property Window(as integer) as hwnd
      declare property Terminated as boolean
      declare property Terminated (as boolean)
      declare sub Run
      declare sub Terminate
      declare sub Quit
      declare sub DoEvents
      declare operator cast as pframe
      declare constructor
      declare destructor
end type

common shared as PApplication iApplication
#define Application (*(iApplication))

#include once "gui.inc"

/'QObject'/
operator QObject.cast as object
    return this
end operator

operator QObject.cast as string
    return "QObject"
end operator

/'QFrame'/
sub QFrame.Refresh
    Style=fstyle
    ExStyle=fexstyle
    repaint
    if IsWindow(fhandle) then RedrawWindow(fhandle, 0, 0, RDW_ERASE or RDW_INVALIDATE)
    update
end sub

sub QFrame.Add(v as pframe)
    dim as integer i=indexof(v)
    if i=-1 then
        fcontrolcount+=1
        fcontrols=reallocate(fcontrols,sizeof(pframe)*fcontrolcount)
        fcontrols[fcontrolcount-1]=v
    end if
end sub

sub QFrame.Remove(v as pframe)
    dim as integer x=indexof(v)
    for i as integer=x to fcontrolcount-1
        fcontrols[i]=fcontrols[i+1]
    next
    fcontrolcount-=1
    fcontrols=reallocate(fcontrols,sizeof(pframe)*fcontrolcount)
end sub

function QFrame.IndexOf(v as pframe) as integer
    if v=0 then return -2
    for i as integer=0 to fcontrolcount-1
        if fcontrols[i]=v then return i
    next
    return -1
end function

sub QFrame.Dispatch(byref m as QMessage)
    select case m.msg
    case wm_nccreate
           SetWindowLongPtr(m.dlg,GetClassLongPtr(m.dlg,gcl_cbwndextra)-sizeof(integer),cint(@this))
           SetProp(GetParent(m.dlg),"THIS",@this)
           SetProp(m.dlg,"FreeBasicObject",@this)
           self=0
           m.result=0
     case wm_create
           ffont->interface=fhandle  
           for i as integer=0 to fcontrolcount-1 
               fcontrols[i]->CreateHandle   
           next
           m.result=0
     case wm_initdialog
           if oninitdialog then oninitdialog(this)
           m.result=0
     case wm_paint
           dim as wndclassex wcls
           wcls.cbsize=sizeof(wcls)
           if getclassinfoex(0,classancestor,@wcls)=0 then
               if getclassinfoex(instance,classancestor,@wcls)=0 then
                  dim as paintstruct ps
                  dim as hdc dc=beginpaint(fhandle,@ps)
                  fillrect(dc,@ps.rcpaint,fbrush->handle)
                  if fonpaint then fonpaint(this)
                  endpaint(fhandle,@ps)
                  m.result=0
               else
                  if fonpaint then fonpaint(this)
               end if
           else
               if fonpaint then fonpaint(this)
           end if
           m.result=0
    case wm_destroy
         fhandle=0
         RemoveProp(GetParent(m.dlg),"this")
         RemoveProp(m.dlg,"FreeBasicObject")
         fmodalresult=m.wparam
         m.result=fmodalresult
    case wm_copydata
         dim as copydatastruct ptr cs=cast(copydatastruct ptr,m.lparam)
         dim as hwnd From=cast(hwnd,m.wparam)
         if ondata then ondata(this,From,cs)
         m.result=0
    case wm_showwindow,wm_initdialog
         'fcanvas.Control=m.dlg
         for i as integer=0 to fcontrolcount-1
             fcontrols[i]->CreateHandle  
         next
         m.result=0
    case wm_size
         RequestAlign
         if fparent then fparent->RequestAlign
         m.result=0
    case wm_windowposchanged
         RequestAlign
         if fparent then fparent->RequestAlign
         m.result=0
    case wm_command  
         if iswindow(cast(hwnd,m.lparam)) then   
            SendMessage(cast(hwnd,m.lparam),cm_command,m.wparam,m.lparam)
         elseif m.lparam=0 then  
            if hiword(m.wparam)=0 then  
               if onMenu then onMenu(this,loword(m.wparam))
            elseif hiword(m.wparam)=1 then
               if onAccel then onAccel(this,loword(m.wparam))
            end if  
         end if
         m.result=0
    case cm_command
         fid=loword(m.wparam)
         dim as integer code=hiword(m.lparam),fid=loword(m.wparam)
         if onCommand then onCommand(this,code,fid,cast(hwnd,m.lparam))
         m.result=0
    case wm_notify
         dim as lpnmhdr nm=cast(lpnmhdr,m.lparam)
         if nm then
            m.result=SendMessage(nm->hwndFrom,cm_notify,0,m.lparam)
         else
            m.result=0
         end if
    case cm_notify
         dim as lpnmhdr nm=cast(lpnmhdr,m.lparam)
         if (nm>0) then
            select case m.msg
            case nm_click
                 Click
                 m.result=0
            case nm_dblclk
                 DblClick
                 m.result=0
            end select/''/
         else
            m.result=0
         end if
    case wm_parentnotify
         select case loword(m.wparam)
         case wm_create
              m.result=0
         case wm_destroy
              m.result=0
         case wm_lbuttondown
              m.result=0
         case wm_mbuttondown
              m.result=0
         case wm_rbuttondown
              m.result=0
         case wm_xbuttondown
              m.result=0
         end select
         m.result=0
    case wm_cancelmode
        if GetCapture = m.dlg then
            ReleaseCapture
            SendMessage(m.dlg,WM_LBUTTONUP,0,&HFFFFFFFF)
        end if
        m.result = 0
    case wm_setfocus
         if fParent then
            fParent->factive=@this
         end if
         m.result=0
    case wm_killfocus
         if fParent then if @this=fParent->factive then fParent->factive=0
         m.result=0
    case wm_lbuttondown
         if onMouseDown then onMouseDown(this,MK_LBUTTON,loword(m.lparam),hiword(m.lparam),m.wparam and &hffff)
         m.result=0
    case wm_lbuttonup
         if onMouseUp then onMouseUp(this,MK_LBUTTON,loword(m.lparam),hiword(m.lparam),m.wparam and &hffff)
         m.result=0
    case wm_rbuttondown
         if onMouseDown then onMouseDown(this,MK_RBUTTON,loword(m.lparam),hiword(m.lparam),m.wparam and &hffff)
         /'if fpopupmenu then
            dim as point pt=type(loword(m.lparam),hiword(m.lparam))
            clienttoscreen(pt)
            TrackPopupMenu(fpopupmenu->handle,0,pt.x,pt.y,0,fhandle,0)
         end if'/
         m.result=0
    case wm_rbuttonup
         if onMouseUp then onMouseUp(this,MK_RBUTTON,loword(m.lparam),hiword(m.lparam),m.wparam and &hffff)
         m.result=0
    case wm_mbuttondown
         if onMouseDown then onMouseDown(this,MK_MBUTTON,loword(m.lparam),hiword(m.lparam),m.wparam and &hffff)
         m.result=0
    case wm_mbuttonup
         if onMouseUp then onMouseUp(this,MK_MBUTTON,loword(m.lparam),hiword(m.lparam),m.wparam and &hffff)
         m.result=0
    case wm_mousemove
         if onMouseMove then onMouseMove(this,loword(m.lparam),hiword(m.lparam),m.wparam and &hffff)
         m.result=0
    case wm_char
         if onKeyPress then onKeyPress(this,cast(byte,m.wparam))
         m.result=0
    case wm_keydown
         if onKeyDown then onKeyDown(this,cast(word,m.wparam),m.wparam and &hffff)
         m.result=0
    case wm_keyup
         if onKeyUp then onKeyUp(this,cast(word,m.wparam),m.wparam and &hffff)
         m.result=0
    case wm_getdlgcode
         m.result=dlgc_wantallkeys
    case wm_ctlcolordlg to wm_ctlcolorstatic
         m.result=sendmessage(cast(hwnd,m.lparam),cm_ctlcolor,m.wparam,cint(fhandle))
    case cm_ctlcolor
         setbkmode(cast(hdc,m.wparam),transparent)
         setbkcolor(cast(hdc,m.wparam),fcolor)
         settextcolor(cast(hdc,m.wparam),ffont->color)
         setbkmode(cast(hdc,m.wparam),OPAQUE)
         m.result=cint(fbrush->handle)
    end select
end sub

sub QFrame.Handler(byref m as QMessage)
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    if GetClassInfoEx(0,classancestor,@wcls) then
       m.result=CallWindowProc(wcls.lpfnwndproc,m.dlg,m.msg,m.wparam,m.lparam)
    elseif GetClassInfoEx(instance,classancestor,@wcls) then
       m.result=CallWindowProc(wcls.lpfnwndproc,m.dlg,m.msg,m.wparam,m.lparam)
    else
       m.result=DefWindowProc(m.dlg,m.msg,m.wparam,m.lparam)
    end if
end sub

sub QFrame.CreateHandle
    FreeHandle
    self=@this
    CreateWindowEx(fexstyle,classname,ftext,fstyle,fleft,ftop,fwidth,fheight,iif(fparent,fparent->fhandle,fparentwnd),cast(hmenu,fid),instance,0)
    if iswindow(fhandle) then
       EnableWindow(fhandle,fenabled)
       
       if this is QForm then
          select case cast(PForm,@this)->windowstate
          case wsnormal
            ShowWindow(fhandle,iif(fvisible,sw_show,sw_hide))
          case wshide
            ShowWindow(fhandle,sw_hide)
          case wsminimized
            ShowWindow(fhandle,sw_minimize)
          case wsmaximized
            ShowWindow(fhandle,sw_maximize)
          end select
       else
          ShowWindow(fhandle,iif(fvisible,sw_show,sw_hide))
       end if
       SendMessage(fhandle,wm_setfont,cint(ffont->handle),1)/''/
       UpdateWindow(fhandle)
    end if
end sub

function QFrame.Perform(msg as uint,wparam as wparam,lparam as lparam) as lresult
    return SendMessage(fhandle,msg,wparam,lparam)
end function

property QFrame.ControlStyle as integer
    return fcontrolstyle
end property

property QFrame.ControlStyle(v as integer)
    fcontrolstyle=v
end property

property QFrame.ControlState as integer
    return fcontrolstate
end property

property QFrame.ControlState(v as integer)
    fcontrolstate=v
end property

property QFrame.Cursor as integer
    return cint(fcursor->handle)
end property

property QFrame.Cursor(v as integer)
    fcursor->handle=cast(hcursor,v)
end property

property QFrame.Hint as string
    return fhint
end property

property QFrame.Hint (v as string)
    fhint=v
end property

property QFrame.ShowHint as boolean
    return fShowhint
end property

property QFrame.ShowHint (v as boolean)
    fShowhint=v
end property

property QFrame.Clipped as boolean
    return fclipped
end property

property QFrame.Clipped (v as boolean)
    fclipped=v
end property

property QFrame.Grouped as boolean
    return fGrouped
end property

property QFrame.Grouped (v as boolean)
    fGrouped=v
end property

property QFrame.TabStop as boolean
    return fTabStop
end property

property QFrame.TabStop(v as boolean)
    fTabStop=v
end property

property QFrame.id as integer
    return fid
end property

property QFrame.id(v as integer)
    fid=v
end property

property QFrame.onPaint as QEvent
    return fonpaint
end property

property QFrame.onPaint (v as QEvent)
    fonpaint=v
    invalidate
end property

property QFrame.Color as integer
    if iswindow(fhandle) then
       dim as hdc dc=GetDc(fhandle)
       dim as hbrush nw,temp=selectObject(dc,nw)
       dim as logbrush lb
       if GetObject(temp,sizeof(logbrush),@lb) then
          fcolor=lb.lbcolor
          deleteobject(selectObject(dc,temp))
          releasedc(fhandle,dc)
       end if
    end if
    return fcolor
end property

property QFrame.Color (v as integer)
    fcolor=v
    if fbrush then
       fbrush->color=v
       Invalidate
    end if
end property

property QFrame.Style as integer
    if iswindow(fhandle) then fstyle=GetWindowLongPtr(fhandle,gwl_style)
    return fstyle
end property

property QFrame.Style (v as integer)
    fstyle=v
    if iswindow(fhandle) then
       SetWindowLongPtr(fhandle,gwl_style,v)
       SetWindowPos(fhandle,0,0,0,0,0,swp_noactivate or swp_nomove or swp_nosize or swp_nozorder or swp_framechanged)
       updateWindow(fhandle)
    end if
end property

property QFrame.ExStyle as integer
    if iswindow(fhandle) then fexstyle=GetWindowLongPtr(fhandle,gwl_exstyle)
    return fexstyle
end property

property QFrame.ExStyle (v as integer)
    fexstyle=v
    if iswindow(fhandle) then
       SetWindowLongPtr(fhandle,gwl_exstyle,v)
       SetWindowPos(fhandle,0,0,0,0,0,swp_noactivate or swp_nomove or swp_nosize or swp_nozorder or swp_framechanged)
       updateWindow(fhandle)
    end if
end property

property QFrame.Handle as hwnd
    return fhandle
end property

property QFrame.Handle (v as hwnd)
end property

property QFrame.Font as QFont
    if ffont then
       return *ffont
    else
       return *cast(PFont,0)
    end if
end property

property QFrame.Font(v as QFont)
    ffont=v
    v.interface=fhandle
end property

property QFrame.ParentWnd as hwnd
    if iswindow(fhandle) then
       fparentwnd=GetParent(fhandle)
       if GetClassLongPtr(fparentwnd,gcl_cbwndextra)>0 then fparent=objFromHwnd(fparentwnd)
    end if
    return fparentwnd
end property

property QFrame.ParentWnd (v as hwnd)
    dim as hwnd saveParentWnd=fparentWnd
    dim as PFrame saveParent=objFromHwnd(saveParentWnd)
    fparentwnd=v
    if GetClassLongPtr(fparentwnd,gcl_cbwndextra)>0 then fparent=objFromHwnd(v)
    if saveparent then saveparent->remove(@this)
    if fparent then fparent->add(@this)
    if iswindow(fhandle) then
       SetParent(fhandle,v)
    else
       CreateHandle
    end if
end property

property QFrame.Parent as pframe
    return fparent
end property

property QFrame.Parent (v as pframe)
    dim as pframe saveparent=fparent
    fparent=v
    if saveparent then saveparent->remove(@this)
    if v then v->Add(@this)
    if iswindow(fhandle) then
       SetParent(fhandle,iif(v,v->fhandle,0))
    else
       CreateHandle  
    end if
end property

property QFrame.Align as integer
    return falign
end Property

property QFrame.Align(value as integer)
    falign = value
    if fparent then
       fparent->RequestAlign
       fParent->Repaint
    end if
end Property

property QFrame.Left as integer
    if isWindow(fHandle) then
       GetWindowRect(fHandle,@fclientrect)
       MapWindowPoints(0,GetParent(fHandle),cast(point ptr,@fclientrect),2)
       fleft=fclientrect.Left
    end if
    return fleft
end property

property QFrame.Left (v as integer)
    fleft=v
    if isWindow(fHandle) then
       MoveWindow(fHandle,fleft,ftop,fwidth,fheight,1)
       if fParent then fParent->RequestAlign
    end if
end property

property QFrame.Top as integer
    if isWindow(fHandle) then
       GetWindowRect(fHandle,@fclientrect)
       MapWindowPoints(0,GetParent(fHandle),cast(point ptr,@fclientrect),2)
       ftop=fclientrect.Top
    end if
    return ftop
end property

property QFrame.Top (v as integer)
    ftop=v
    if isWindow(fHandle) then
       MoveWindow(fHandle,fleft,ftop,fwidth,fheight,1)
       if fParent then fParent->RequestAlign
    end if
end property

property QFrame.Width as integer
    if isWindow(fHandle) then
       GetWindowRect(fHandle,@fclientrect)
       MapWindowPoints(0,GetParent(fHandle),cast(point ptr,@fclientrect),2)
       fwidth=fclientrect.Right-fclientrect.Left
    end if
    return fwidth
end property

property QFrame.Width (v as integer)
    fwidth=v
    if isWindow(fHandle) then
       MoveWindow(fHandle,fleft,ftop,fwidth,fheight,1)
       if fParent then fParent->RequestAlign
    end if
end property

property QFrame.Height as integer
    if isWindow(fHandle) then
       GetWindowRect(fHandle,@fclientrect)
       MapWindowPoints(0,GetParent(fHandle),cast(point ptr,@fclientrect),2)
       fheight=fclientrect.Bottom-fclientrect.Top
    end if
    return fheight
end property

property QFrame.Height (v as integer)
    fheight=v
    if isWindow(fHandle) then
       MoveWindow(fHandle,fleft,ftop,fwidth,fheight,1)
       if fParent then fParent->RequestAlign
    end if
end property

property QFrame.ClientWidth as integer
    if isWindow(fHandle) then
       GetClientRect(fHandle,@fClientRect)
       fClientWidth=fClientRect.Right
    end if
    return fclientwidth
end property

property QFrame.ClientWidth(v as integer)
end property

property QFrame.ClientHeight as integer
    if isWindow(fHandle) then
       GetClientRect(fHandle,@fClientRect)
       fClientHeight=fClientRect.Bottom
    end if
    return fclientheight
end property

property QFrame.ClientHeight(v as integer)
end property

property QFrame.ClientRect as rect
    if isWindow(fHandle) then GetClientRect(fHandle,@fclientrect)
    return fclientrect
end property

property QFrame.ClientRect(v as rect)
    fclientrect=v
    AdjustClient(v)
end property

property QFrame.WindowRect as rect
    if isWindow(fHandle) then GetWindowRect(fHandle,@fwindowrect)
    return fwindowrect
end property

property QFrame.WindowRect(v as rect)
end property

property QFrame.Enabled as boolean
     if isWindow(fHandle) then fEnabled=IsWindowEnabled(fHandle)
     return fEnabled
end property

property QFrame.Enabled (v as boolean)
    fEnabled=v
    if isWindow(fHandle) then EnableWindow(fHandle,fEnabled)
end property

property QFrame.Visible as boolean
    if isWindow(fHandle) then fVisible=IsWindowVisible(fHandle)
    return fVisible
end property

property QFrame.Visible (v as boolean)
    fVisible=v
    if isWindow(fHandle) then
       ShowWindow(fHandle,iif(v,sw_show,sw_hide))
       'if not v then fwindowstate=wsHide else fwindowstate=wsNormal
    end if
end property

property QFrame.Text as string
    if isWindow(fHandle) then
       dim as integer i=GetWiNdowTextLength(fHandle)
       fText=space(i)+chr(0)
       GetWindowText(fHandle,fText,len(fText))
    end if
    return fText
end property

property QFrame.Text (v as string)
    fText=v
    if isWindow(fHandle) then SetWindowText(fHandle,fText)
end property

property QFrame.ControlCount as integer
    return fcontrolcount
end property

property QFrame.Control(i as integer) as PFrame
    if i>-1 and i<fcontrolcount then return fcontrols[i]
end property

operator QFrame.cast as pobject
    return @this
end operator

sub QFrame.FreeHandle
    if iswindow(fhandle) then
       DestroyWindow(fhandle)
       fhandle=0
    end if
end sub

sub QFrame.Recreate
    CreateHandle
end sub

sub QFrame.UpdateControl
    if iswindow(GetParent(fhandle))then
       dim as copydatastruct cd
       cd.cbData=sizeof(cd)
       cd.dwData=cm_update
       cd.lpData=(@this)
       if style and wm_parentnotify=wm_parentnotify then
          sendmessage(GetParent(fhandle),wm_copydata,cint(fhandle),cint(@cd))
       end if
       sendmessage(fhandle,cm_update,cint(fhandle),cint(@cd))
    end if
end sub

sub QFrame.AdjustClient overload(v as rect)
    dim as integer borderX=GetSystemMetrics(sm_cxborder),borderY=GetSystemMetrics(sm_cyborder),captionY=GetSystemMetrics(sm_cycaption)
    v.bottom+=captionY+2*borderY
    v.right+=2*borderX
    SetBounds(fleft,ftop,v.right,v.bottom)
end sub

sub QFrame.AdjustClient overload(x as integer,y as integer,cx as integer,cy as integer)
    dim as rect r=type(x,y,cx,cy)
    AdjustClient(r)
end sub

sub QFrame.Click
    if onclick then onclick(this)
end sub

sub QFrame.DblClick
    if ondblclick then ondblclick(this)
end sub

sub QFrame.BringToFront
    if IsWindow(fhandle) then
        'dim as HWND Dlg = GetTopWindow(fhandle)
        'while ( Dlg )
        '    foldz += 1
        '    GetnextWindow( Dlg, GW_HWNDnext)
        'wend
        foldZ = IndexOf(@this)
        BringWindowToTop(fhandle)
    end if
end sub

sub QFrame.SendToBack
    if IsWindow(fhandle) then
        SetWindowPos(fhandle,fcontrols[foldz]->fhandle, 0, 0 ,0 ,0, SWP_NOMOVE or SWP_NOACTIVATE or SWP_NOSIZE)
    end if
end sub

sub QFrame.SetFocus
    if IsWindow(fhandle) then .SetFocus(fhandle)
end sub

sub QFrame.KillFocus
    if IsWindow(fhandle) then Perform(WM_KILLFOCUS, 0, 0)
end sub

sub QFrame.Invalidate
    if IsWindow(fhandle) then InvalidateRect(fhandle, 0, 0)
end sub

sub QFrame.Repaint
    if IsWindow(fhandle) then RedrawWindow(fhandle, 0, 0, RDW_INTERNALPAINT)
end sub

'sub QFrame.Refresh
'    if IsWindow(fhandle) then RedrawWindow(fhandle, 0, 0, RDW_ERASE or RDW_INVALIDATE)
'end sub

sub QFrame.Update
    if IsWindow(fhandle) then UpdateWindow(fhandle)
end sub

sub QFrame.ClientToScreen(byref p as point)
    if IsWindow(fhandle) then .ClientToScreen(fhandle,@p)
end sub

sub QFrame.ScreenToClient(byref p as point)
    if IsWindow(fhandle) then .ScreenToClient(fhandle,@p)
end sub

sub QFrame.SetBounds overload(x as integer,y as integer,cx as integer,cy as integer)
    fleft=x
    ftop=y
    fwidth=cx
    fheight=cy
    if iswindow(fhandle) then MoveWindow(fhandle,fleft,ftop,fwidth,fheight,1)
end sub

sub QFrame.SetBounds overload(v as rect)
    SetBounds(v.left,v.top,v.right,v.bottom)
end sub

sub QFrame.RequestAlign
     dim as PFrame ptr ListLeft, ListRight, Listtop, ListBottom, ListClient
     dim as integer i,LeftCount = 0, RightCount = 0, topCount = 0, BottomCount = 0, ClientCount = 0
     dim as integer ttop, btop, lLeft, rLeft
     dim as integer aLeft, atop, aWidth, aHeight
     if fControlCount=0 then exit sub
     lLeft = 0
     rLeft = ClientWidth
     ttop  = 0
     btop  = ClientHeight
     for i = 0 to fControlCount -1
         aleft = fcontrols[i]->left
         atop = fcontrols[i]->top
         awidth = fcontrols[i]->width
         aheight = fcontrols[i]->height
         select case fcontrols[i]->Align
                case 1'alLeft
                    LeftCount += 1
                    ListLeft = reallocate(ListLeft,sizeof(PFrame)*LeftCount)
                    ListLeft[LeftCount -1] =fcontrols[i]
                case 2'alRight
                    RightCount += 1
                    ListRight = reallocate(ListRight,sizeof(PFrame)*RightCount)
                    ListRight[RightCount -1] = fcontrols[i]
                case 3'altop
                    topCount += 1
                    Listtop = reallocate(Listtop,sizeof(PFrame)*topCount)
                    Listtop[topCount -1] = fcontrols[i]
                case 4'alBottom
                    BottomCount += 1
                    ListBottom = reallocate(ListBottom,sizeof(PFrame)*BottomCount)
                    ListBottom[BottomCount -1] = fcontrols[i]
                case 5'alClient
                    ClientCount += 1
                    ListClient = reallocate(ListClient,sizeof(PFrame)*ClientCount)
                    ListClient[ClientCount -1] = fcontrols[i]
          end select
     next i

   for i = 0 to topCount -1
      with *Listtop[i]
         if .fvisible then
            ttop += .Height
            .SetBounds(0,ttop - .Height,rLeft,.Height)
         end if
      end with
   next i
   'btop = ClientHeight
   for i = 0 to BottomCount -1
      with *ListBottom[i]
         if .fvisible then
            btop -= .Height
            .SetBounds(0,btop,rLeft,.Height)
         end if
      end with
   next i
   'lLeft = 0
   for i = 0 to LeftCount -1
      with *ListLeft[i]
         if .fvisible then
            lLeft += .Width
            .SetBounds(lLeft - .Width, ttop, .Width, btop - ttop)
         end if
      end with
   next i
   'rLeft = ClientWidth
   for i = 0 to RightCount -1
      with *ListRight[i]
         if .fvisible then
            rLeft -= .Width
            .SetBounds(rLeft, ttop, .Width, btop - ttop)
         end if
      end with
   next i
   for i = 0 to ClientCount -1
      with *ListClient[i]
         if .fvisible then
            .SetBounds(lLeft,ttop,rLeft - lLeft,btop - ttop)
         end if
      end with
   next i
    if ListLeft   then deallocate ListLeft
    if ListRight  then deallocate ListRight
    if Listtop    then deallocate Listtop
    if ListBottom then deallocate ListBottom
    if ListClient then deallocate ListClient
end sub

operator QFrame.cast as string
    if classname<>"" then
       return classname
    else
       return "QFrame"
    end if
end operator

constructor QFrame
    ffont=new QFont
    fbrush=new QBrush
    fpopupmenu=new QPopupMenu
    fenabled=true
    fvisible=true
end constructor

destructor QFrame
    if ffont then delete ffont
    if fbrush then delete fbrush
    if fpopupmenu then delete fpopupmenu
end destructor

/'QGeneric'/
function QGeneric.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as pframe f=iif(self,self,cast(pframe,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-sizeof(integer))))
    dim as QMessage m=type(dlg,msg,wparam,lparam,0,f)
    if f then
       f->fhandle=dlg
       f->Dispatch(m)
       if m.result=0 then f->Handler(m)
       return m.result
    else
       f=new QGeneric
       f->fhandle=dlg
       f->Dispatch(m)
       if m.result=0 then f->Handler(m)
       return m.result
    end if
    return m.result
end function

function QGeneric.Register as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    wcls.hinstance=instance
    wcls.lpszclassname=cast(zstring ptr,@"QGeneric")
    wcls.lpfnwndproc=@dlgproc
    wcls.hcursor=LoadCursor(0,idc_arrow)
    wcls.cbwndextra+=sizeof(integer)
    return RegisterClassEx(@wcls)
end function

property QGeneric.Parent as pframe
    return Base.fparent
end property

property QGeneric.Parent (v as pframe)
    classname=fhost
    Base.Parent=v
end property

property QGeneric.Host as string
    return classname
end property

property QGeneric.Host (v as string)
    classname=v
    Base.CreateHandle
end property

operator QGeneric.cast as pframe
    return @this
end operator

constructor QGeneric
    fhost="QGeneric"
    fwidth=50
    fheight=50
    fstyle=ws_child
end constructor

destructor QGeneric
end destructor

/'QForm'/
function QForm.DlgProc(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as pframe f=iif(self,self,cast(pframe,GetWindowLongPtr(dlg,GetClassLongPtr(dlg,gcl_cbwndextra)-sizeof(integer))))
    dim as qmessage m=type(dlg,msg,wparam,lparam,0,f)
    if f then
       f->fhandle=dlg
       f->dispatch(m)
       if m.result=0 then f->Handler(m)
       return m.result
    else
       f=new QForm
       f->fhandle=dlg
       f->dispatch(m)
       if m.result=0 then f->Handler(m)
       return m.result
    end if
    return m.result
end function

function QForm.Register(v as string="QForm") as integer
    dim as wndclassex wcls
    wcls.cbsize=sizeof(wcls)
    wcls.lpszclassname=strptr(v)
    wcls.lpfnwndproc=@dlgproc
    wcls.hinstance=instance
    wcls.cbwndextra+=sizeof(integer)
    wcls.hcursor=loadcursor(0,idc_arrow)
    wcls.hbrbackground=cast(hbrush,16)
    return RegisterClassEx(@wcls)
end function

sub QForm.Handler(byref m as QMessage)
    Base.Handler(m)
end sub

sub QForm.Dispatch(byref m as QMessage)
    Base.Dispatch(m)
    select case m.msg
    case wm_create
         if fmainmenu then  
            if ismenu(fmainmenu->handle) then fmainmenu->refresh(fhandle)
         end if
         if onCreate then onCreate(this)  
         m.result=0
    case wm_showwindow
         if onShow then onShow(this)
         m.result=0
    case wm_close
         dim as integer closeAction=1
         if onClose then onClose(this,closeaction)
         select case closeAction
         case 0:m.result=1
         case 1:m.result=0:if this is QApplication then ExitProcess(0)
         case 2:ShowWindow(fhandle,sw_hide):m.result=1
         case 3:ShowWindow(fhandle,sw_minimize):m.result=1
         case 4:ShowWindow(fhandle,sw_maximize):m.result=1
         end select
    end select
    
end sub

property QForm.Icon byref as QIcon
    if ficon then
       return *ficon
    else
       return *cast(picon,0)
    end if
end property

property QForm.Icon (byref v as QIcon)
    ficon=v
    repaint
end property

property QForm.WindowState as integer
    if iswindow(fhandle) then
       if isiconic(fhandle) then
          fwindowstate=wsminimized
       elseif iszoomed(fhandle) then
          fwindowstate=wsmaximized
       elseif not iswindowvisible(fhandle) then
          fwindowstate=wshide
       else
          fwindowstate=wsnormal
       end if
    end if
    return fwindowstate
end property

property QForm.WindowState (v as integer)
    fwindowstate=v
    select case v
    case wsnormal
         ShowWindow(fhandle,sw_normal)
    case wsminimized
         ShowWindow(fhandle,sw_minimize)
    case wsmaximized
         ShowWindow(fhandle,sw_maximize)
    case wsHide
         ShowWindow(fhandle,sw_hide)
    end select
end property

property QForm.PopupMenu byref as QPopupMenu
    if fpopupmenu then
       return (*(fpopupmenu))
    else
       return (*cast(ppopupMenu,0))
    end if
end property

property QForm.PopupMenu (byref v as QPopupMenu)
    fpopupmenu=v
end property

property QForm.MainMenu byref as QMainMenu
    if fmainmenu then
       return *(fmainmenu)
    else
       return *cast(pmainmenu,0)
    end if
end property

property QForm.MainMenu (byref v as QMainMenu)
    fmainmenu=v
    if v then v.refresh(fhandle)
end property/''/

property QForm.BorderIcons as integer
    return fbordericons
end property

property QForm.BorderIcons (v as integer)
    fbordericons=v
end property

property QForm.FormStyle as integer
    return fformstyle
end property

property QForm.FormStyle (v as integer)
    fformstyle=v
end property

property QForm.FormBorder as integer
    return fformstyle
end property

property QForm.FormBorder (v as integer)
    fformstyle=v
end property

function QForm.ShowModal as integer
     for i as integer=0 to application.winlist.count-1
          if application.window(i)<>fhandle then enablewindow(application.window(i),0)
     next
     fvisible=showwindow(fhandle,sw_show)
     do
       application.doevents
     loop until application.terminated or (iswindow(fhandle)=0)
     for i as integer=0 to application.winlist.count-1
          if application.window(i)<>fhandle then enablewindow(application.window(i),1)
     next
     return fmodalresult
end function

sub QForm.Close
    if iswindow(fhandle) then perform(wm_close,cint(fmodalresult),0)
end sub

operator QForm.cast as pframe
    return @this
end operator

operator QForm.cast as string
    if classname<>"" then
       return classname
    else
       return "QForm"
    end if
end operator

constructor QForm
    classname="QForm"
    fstyle=ws_overlappedwindow
    fwidth=400
    fheight=250
    fmainmenu=new QMainMenu
end constructor

destructor QForm
    if fmainmenu then delete fmainmenu
end destructor

/'QApplication'/
function QApplication.EnumWindowsProc(dlg as hwnd,w as lparam) as boolean
     if w>0 then
        with *cast(PList,w)
               .Add(dlg)
        end with
     end if
     return false
end function

sub QApplication.UpdateWindowsList
     fwindows.clear
     EnumThreadWindows(GetCurrentThreadId,cast(wndenumproc,@enumwindowsproc),cint(@fwindows))
end sub

property QApplication.WinList byref  as QList
     updatewindowsList
     return fwindows
end property

property QApplication.WindowCount as integer
     updatewindowsList
     return fwindows.count
end property

property QApplication.Window(i as integer) as hwnd
     updatewindowsList
     if i>-1 and i<fwindows.count then return  cast(hwnd,fwindows.item(i))
     return 0
end property

property QApplication.Terminated as boolean
     return fterminated
end property

property QApplication.Terminated (v as boolean)
     dim as boolean state=fterminated
     fterminated=v
     if v then Terminate
end property

sub QApplication.Terminate
     ExitProcess(0)
     fterminated=1
end sub

sub QApplication.Quit
     PostQuitMessage(0)
end sub

sub QApplication.DoEvents
     dim as msg m
     if peekmessage(@m,0,0,0,pm_remove)>0 then
        translatemessage(@m)
        dispatchmessage(@m)
     end if
end sub

sub QApplication.Run
    fterminated=0
    dim as msg m
    if onShow then onShow(this)
    while GetMessage(@m,0,0,0)>0
          TranslateMessage(@m)
          DispatchMessage(@m)
    wend
end sub

operator QApplication.cast as pframe
    return @this
end operator

constructor QApplication
    #ifdef autocreate
    QForm.Register
    classname="QForm"
    fexstyle=ws_ex_appwindow
    fstyle=ws_overlappedwindow
    fwidth=700
    fheight=500
    Parent=0
    ShowWindow(fhandle,sw_show)
    #endif
end constructor

destructor QApplication
    terminate
end destructor

#include once "standards.bas"


sub gui_initialization constructor
     iApplication=new qapplication
     QForm.Register
     #ifdef rtl
         PropInfo=new QELPropInfo
     #endif
end sub

sub gui_finalization destructor
     delete iapplication
     unregisterclass("QForm",instance)
     #ifdef rtl
        delete PropInfo
     #endif
end sub
